#include <stdio.h>
#include <vector>
#include "stan/agrad/agrad.hpp"

using namespace stan::agrad;

int main() {
  printf("stan::agrad Automatic Gradient Demo\n");

  printf("f(x1,x2) = 5.0 * x1 * x2");
  var x1 = 2.0;
  var x2 = 3.0;
  std::vector<double> g;
  std::vector<var> x;
  x.push_back(x1);
  x.push_back(x2);
  var f = 5.0 * x1 * x2;
  f.grad(x,g);
  printf("  x1=%f  x2=%f  f(x1,x2)=%f\n",
	 x1.val(), x2.val(), f.val());
printf("    d/dx1 f(x1,x2)=%f  d/dx2 f(x1,x2)=%f\n",
       g[0], g[1]);

}


