#include <stdio.h>
#include <vector>
#include "stan/agrad/agrad.hpp"
// #include "stan/agrad/agrad_eigen.hpp"
#include "Eigen/Dense"


int main() {

  using namespace Eigen;
  using namespace stan::agrad;

  Matrix<var,Dynamic,Dynamic> a(1,2);
  a << 1.0, 2.0;
  
  Matrix<var,Dynamic,Dynamic> b(2,1);
  b << -1.0, -10.0;
  
  std::vector<var> x;
  x.push_back(a(0,0)); 
  x.push_back(a(0,1)); 
  x.push_back(b(0,0)); 
  x.push_back(b(1,0));

  Matrix<var,Dynamic,Dynamic> c = a * b; 

  std::vector<double> grad;
  c(0,0).grad(x,grad);

  printf("\nProblem\n");
  printf("  a = [1,2]  b=[-1,-10]'\n");
  printf("  c = a*b = a00*b00 + a01*b10 = [-21]\n");
  printf("  dc/da00 = b00,  ..., dc/db10 = a01\n");
  printf("\nstan::agrad + Eigen\n");
  printf("  c(0,0) =%f\n", c(0,0).val());
  printf("  dc/da00=%f  dc/da01=%f\n",
	 grad[0], grad[1]);
}
